unit CennikListView;

interface

uses Controls, Classes, Graphics, Types;

type
    TColoredString = packed record
        Contents: String;
        Color: TColor;
        BackColor: TColor;
        Ad: Pointer;
        IDSklepu: Byte;
        PartHide: Boolean;
        end;

    evSelectItem = procedure(Index: Cardinal) of object;
    evDblClick = procedure(Karta: Pointer; Sklep: Byte) of object;

    TCennikListView = class(TCustomControl)
    protected
        _Offset: Cardinal;
        _MaxItems: Word;
        _OnNotify: TNotifyEvent;
        _OnSelectItem: evSelectItem;
        _OnDblClick: evDblClick;
        WysAdin: Integer;
        procedure DblClick; override;
        procedure Paint; override;
        procedure SetOffset(n: Cardinal);
        procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    public
        Source: array of array of TColoredString;
        LeftFroms: array of Word;
        Selected: Integer;
        constructor Create(AOwner: TComponent); override;
        function VisibleItems: Byte;
        procedure Odswiez;
    published
        property OnDoubleClick: evDblClick read _OnDblClick write _OnDblClick;
        property OnNotify: TNotifyEvent read _OnNotify write _OnNotify;
        property OnSelectItem: evSelectItem read _OnSelectItem write _OnSelectItem;
        property OnMouseWheel;
        property OnDragOver;
        property OnDragDrop;
        property DragMode;
        property DoubleBuffered;
        property ShowHint;
        property MaxItems: Word read _MaxItems write _MaxItems;
        property Offset: Cardinal read _Offset write SetOffset;
    end;

procedure Register;

implementation

procedure Register;
begin
RegisterComponents('Samples',[TCennikListView]);
end;

constructor TCennikListView.Create(AOwner: TComponent);
begin
inherited;
_Offset:=0;
Selected:=-1;
_MaxItems:=15;
end;

procedure TCennikListView.SetOffset(n: Cardinal);
begin
if n=_Offset then exit;
_Offset:=n;
Repaint;
end;

function TCennikListView.VisibleItems: Byte;
begin
Result:=(Height-3) div Canvas.TextHeight('  ');
end;

procedure TCennikListView.Odswiez;
var
a: Integer;
begin
if WysAdin=0 then WysAdin:=Canvas.TextHeight('  ');
Selected:=-1;
a:=Length(Source); if a>_MaxItems then a:=_MaxItems;
Height:=a*WysAdin+4;
if Assigned(_OnNotify) then _OnNotify(Self);
Repaint;
end;

procedure TCennikListView.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
a: Integer;
begin
a:=(Y-2) div WysAdin;
if (a>=VisibleItems) or (a<0) then exit;
Inc(a,_Offset);
Selected:=a;
SetFocus;
if Assigned(_OnSelectItem) then _OnSelectItem(a);
Repaint;
end;

procedure TCennikListView.DblClick;
var
p: TPoint;
a,b,i: Integer;
begin
p:=ScreenToClient(Mouse.CursorPos);
a:=(p.Y-2) div WysAdin;
if (a>=VisibleItems) or (a<0) then exit;
Inc(a,_Offset);
b:=0;
for i:=1 to High(LeftFroms) do if p.X>=LeftFroms[i] then b:=i else break;
if Assigned(_OnDblClick) and Assigned(Source[a,b].Ad) then _OnDblClick(Source[a,b].Ad,Source[a,b].IDSklepu);
end;


procedure TCennikListView.Paint;
var
i,a,j,u,b: Integer;
s: String;
begin
with Canvas do begin
     Brush.Color:=clWindow;
     Pen.Color:=clBlack;
     Rectangle(0,0,Width,Height);
     a:=_Offset;
     WysAdin:=TextHeight(' ');
     for i:=a to High(Source) do begin
         u:=(i-a)*WysAdin+2;
         if u+WysAdin>=Height then break;
         if Selected=i then Brush.Color:=$DDDDDD else Brush.Color:=Source[i,0].BackColor;
         if Brush.Color<>clWindow then FillRect(Rect(1,u,Width-1,u+WysAdin));
         for j:=0 to High(Source[i]) do begin
             if Source[i,j].Color=MaxInt then begin
                 Font.Color:=clBlack;
                 Font.Style:=[fsBold];
             end else begin
                 Font.Color:=Source[i,j].Color;
                 Font.Style:=[];
             end;
             if j=High(LeftFroms) then b:=Width-3-LeftFroms[j] else b:=LeftFroms[j+1]-LeftFroms[j];
             s:=Source[i,j].Contents;
             if TextWidth(s)>=b then begin
                repeat
                      if s='' then break;
                      Delete(s,Length(s),1);
                      until TextWidth(s+'...')<b;
                s:=s+'...';
                Source[i,j].PartHide:=True;
                end else Source[i,j].PartHide:=False;
             TextOut(LeftFroms[j]+2,u,s);
             end;
         end;
     end;
end;


end.
