unit Typy;

interface

uses Graphics, Types, Classes, Dialogs, SysUtils;

type
    TKartaLista = record
           Nazwa: String[50];
           Edycja: ShortInt;
           Cena: Single;
           Ilosc: ShortInt;
           Sklep: Byte;
           Komentarz: String[29];
           Uwagi: String[32];
           end;

    TKarta = record
           Nazwa: String[50];
           Edycja: ShortInt;
           Cena: Single;
           Ilosc: SmallInt;
           Komentarz: String[15];
           Stan: String[3];
           Numer: Word;
           Foliowany: Boolean;
           end;

    Tutu = array of ^TKarta;

    TSklepAtry = record
           Data: String[10];
           Kolor: TColor;
           Mail: String[33];
           Minimalne: Byte;
           NazwaSklepu: String[63];
           Plik: String[15];
           URL: String[63];
           end;

    TSklep = record
           Karty: array of TKarta;
           Atry: TSklepAtry;
           Pftm: Tutu;
           end;

    TTypWyszu = (oNormalnie, oWszystko, oLista);

    TKolo = record
          Fg: TColor;
          Bg: TColor;
          end;

    TSposobSort = (ssNazwa, ssEdycja, ssStan, ssCena);

    TUsta = record
          DialFol: String[255];
          Opcje: array[0..4] of Boolean;
{                                                OpIdent
                                                 OpFoilePocz
                                                 OpNieZera
                                                 OpPrzesWszed
                                                 OpDykta
                                                 OpPasekSt
}         PodJest: Boolean;
          PodSkala: Real;
          PodPkt: TPoint;
          PodRozw: Boolean;
          LisJest: Boolean;
          LisPkt: TPoint;
          MaiPkt: TPoint;
          KomJest: Boolean;
          KomPkt: TPoint;
          Sortowanie: TSposobSort;
          Malejaco: Boolean;
          end;

    TUstaPlik = file of TUsta;

    TFunkDat = function(Tekst: String): Boolean;        // true jeli przerywamy

    TRek = packed record
         Nazwa: String[42];
         Koszt: String[50];
         Kolor: Byte;
         Tekst: packed array[1..800] of Char;
         TekstN: Word;
         Typ: String[36];
         Param: String[8];
         Rzadkosc: Byte;
         Edycje: array[1..30] of Byte;
         end;

    pTRek = ^TRek;

    TPlikBazy = file of TRek;

var
    sklepy: array of TSklep;

const
EdycPtr: array[1..53] of Byte = (
1,3,4,5,6,8,10,11,12,13,14,15,16,17,18,19,20,
21,22,23,24,25,27,29,30,31,32,33,34,36,37,38,40,
41,42,43,45,46,47,48,49,
62,64,66,67,74,75,76,77,78,80,
81,82
);


_Edycje: array[0..82,0..1] of String = (
('Nieznana edycja',                 '??' ),
('Limited Edition Alpha',           '1A' ),
('Limited Edition Beta',            '1B' ),
('Unlimited Edition',               'UN' ),
('Arabian Nights',                  'AN' ),
('Antiquities',                     'AQ' ),
('Revised Edition',                 '3E' ),
('Italian Revised Edition',         'i3E'),
('Legends',                         'LE' ),
('Italian Legends',                 'iLE'),
('The Dark',                        'DK' ),
('Fallen Empires',                  'FE' ),
('Czwarta Edycja',                  '4E' ),
('Ice Age',                         'IA' ),
('Chronicles',                      'CH' ),
('Homelands',                       'HL' ),
('Alliances',                       'AL' ),
('Mirage',                          'MI' ),
('Visions',                         'VI' ),
('Pita Edycja',                    '5E' ),
('Weatherlight',                    'WL' ),
('Portal',                          'P1' ),
('Tempest',                         'TE' ),
('Stronghold',                      'ST' ),
('Exodus',                          'EX' ),
('Portal: Second Age',              'P2' ),
('Unglued',                         'UG' ),
('Urza'#39's Saga',                 'US' ),
('Anthologies',                     'AY' ),
('Urza'#39's Legacy',               'UL' ),
('Szsta Edycja',                   '6E' ),
('Urza'#39's Destiny',              'UD' ),
('Portal: Three Kingdoms',          'P3' ),
('Starter 1999',                    'S1' ),
('Mercadian Masques',               'MM' ),
('Battle Royale',                   'BR' ),
('Nemesis',                         'NE' ),
('Prophecy',                        'PR' ),
('Invasion',                        'IN' ),
('Beatdown',                        'BD' ),
('Planeshift',                      'PL' ),
('Sidma Edycja',                   '7E' ),
('Apocalypse',                      'AP' ),
('Odyssey',                         'OD' ),
('Deckmasters',                     'DM' ),
('Torment',                         'TO' ),
('Judgment',                        'JD' ),
('Onslaught',                       'ON' ),
('Legions',                         'LG' ),
('Scourge',                         'SC' ),
('Vanguard 0',                      'V0' ),
('Vanguard 1',                      'V1' ),
('Vanguard 2',                      'V2' ),
('Vanguard 3',                      'V3' ),
('Vanguard 4',                      'V4' ),
('Vanguard 5',                      'V5' ),
('Vanguard 6',                      'V6' ),
('Vanguard 7',                      'V7' ),
('Vanguard 8',                      'V8' ),
('Vanguard 9',                      'V9' ),
('GURU Lands',                      'GU' ),
('Euro Lands',                      'EU' ),
('Starter 2000',                    'S2' ),
('Renaissance',                     'RN' ),
('sma Edycja',                     '8E' ),
('Magic Player Reward',             'MP' ),
('Promotional',                     'PROMO' ),
('Mirrodin',                        'MR' ),
('World Championships',             'WC' ),
('ARENA Championships',             'ARENA' ),
('DCI Tournaments',                 'DCI' ),
('Prerelease',                      'PRE' ),
('Booster Draft',                   'BOOST' ),
('Edycja specjalna',                'SP' ),
('Darksteel',                       'DS' ),
('Fifth Dawn',                      'FD' ),
('Champions of Kamigawa',           'CK' ),
('Betrayers of Kamigawa',           'BK' ),
('Saviors of Kamigawa',             'SK' ),
('Unhinged',                        'UH' ),
('Dziewita Edycja',                '9E' ),
('Ravnica: City of Guilds',         'RV' ),
('Guildpact',                       'GP' )
);

wer = 'finale';
beta = '';

rok = '2006';

mail = 'pieterer@onet.pl';
web = 'www.pietersoft.prv.pl';

CNazwaId = 'PCen31';
CUstaId = 'PCF+';

wiadomosc = 43274;

Domyslne: TUsta = (
          DialFol: '';
          Opcje: (False, False, False, False, True);
          PodJest: False;
          PodSkala: 0.75;
          PodPkt: (X: 90; Y: 310);
          PodRozw: True;
          LisJest: False;
          LisPkt: (X: 620; Y: 80);
          MaiPkt: (X: 100; Y: 40);
          KomJest: False;
          KomPkt: (X: 620; Y: 310);
          Sortowanie: ssNazwa;
          Malejaco: False;
          );

KoloNormal: TKolo = (
            Fg: clBlack;
            Bg: clWhite;
            );

msUsunCen =
'Wykryto niezgodno pliku "%s" z formatem danych PieterCennika'#13#10+
'i dlatego powinien on zosta usunity.'#13#10#13#10+
'Czy zgadzasz si?';

msNierEdyc =
'Program nie potrafi rozpozna skrtu edycji "%s"'#13#10+
'Skontaktuj si z producentem programu: '+mail;

msNierNazwEdyc =
'Program nie potrafi odczyta nazwy edycji "%s"'#13#10+
'Skontaktuj si z producentem programu: '+mail;

liIlosc = -3;
liEdycja = -2;
liKomentarz = -1;
liCena = 0;

MaxWierszy = 17;
WysWiersza = 13;

MargD = 8;

     kBlue = 1;
     kBlack = 2;
     kRed = 3;
     kGreen = 4;
     kWhite = 5;
     kLand = 6;
     kArtifact = 7;
     kMulti = 8;
     fTimes = 'MPlantin';
     fMagic = 'MagicMedieval';
     tRarN: array[1..4] of String = ('Common','Uncommon','Rare','Land');
     tRarK: array[1..4] of TColor = (clBlack,clSilver,$4DCAEA,clBlack);
     tKolL: array[1..8] of Char = ('U','B','R','G','W',' ','C','O');
     tKolK: array[1..5] of TColor = ($FFCCBB,clDkGray,$7777FF,$00AA00,$AAFFFF);
     tKolKDk: array[1..8] of TColor = (clBlue,clBlack,clMaroon,clGreen,$77EEFF,clWhite,$002266,$DDCCEE);

function OdmienKarte(e: Cardinal): String;
function cEdycje(a: Integer; b: Byte): String;

implementation

function cEdycje(a: Integer; b: Byte): String;
begin
Dec(b);
if b>1 then b:=1;
if a>High(_Edycje) then begin
   if b=1 then Result:='Edycja nr '+IntToStr(a) else Result:='??';
end else Result:=_Edycje[a,b];
end;

function OdmienKarte(e: Cardinal): String;
var
t: Byte;
begin
if e=1 then Result:='' else begin
   t:=e mod 100;
   if ((t div 10)<>1) and ((t mod 10) in [2..4]) then Result:='y' else Result:='';
   end;
Result:=IntToStr(e)+' kart'+Result;
end;

end.
