unit Unit1;

interface

uses
  Windows, Menus, ComCtrls, StdCtrls, Buttons, Controls, ExtCtrls, Classes,
  Forms, SysUtils, Dialogs, Math, Graphics, ToolWin, Typy,
  CennikListView, TlHelp32, Messages;

type
  TFGlowna = class(TForm)
    Nazwa: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    MainMenu1: TMainMenu;
    Opcje: TMenuItem;
    BSzukaj: TButton;
    Oautorze1: TMenuItem;
    StatusBar1: TStatusBar;
    Ustawienia1: TMenuItem;
    TC: TTabControl;
    Informacje1: TMenuItem;
    Pomoc1: TMenuItem;
    Bevel2: TBevel;
    BWszystko: TBitBtn;
    GroupBox2: TGroupBox;
    PokazBaza: TSpeedButton;
    PokazLista: TSpeedButton;
    StatusTimer: TTimer;
    Wypis: TCennikListView;
    ScrollBar1: TScrollBar;
    MDykta: TLabel;
    PokazKomba: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure StworzKomponenty;                   // TMenuItem.Tag oznacza numer sklepu w csklepy
    procedure WczytajCenniki;
    procedure SprawdzButon;
    procedure BSzukajClick(Sender: TObject);
    function UniSzuk(naz: String; ns: Byte; opc: TTypWyszu): Boolean;
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure WczytajDykte;
    procedure LosujDykte;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Ustawienia1Click(Sender: TObject);
    procedure PokazBazaClick(Sender: TObject);
    procedure BWszystkoClick(Sender: TObject);
    procedure KonczWyszu;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure Oautorze1Click(Sender: TObject);
    procedure Pomoc1Click(Sender: TObject);
    procedure StatusTimerTimer(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure WypisNotify(Sender: TObject);
    procedure DopasujWysokosc;
    procedure WypisSelectItem(Index: Cardinal);
    procedure TCChange(Sender: TObject);
    function Pasuje(e: Byte): Boolean;
    procedure WypisDoubleClick(Karta: Pointer; Sklep: Byte);
    procedure Sumama;
    procedure WypisMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure ProcWiadomo(var msg: TMessage); message wiadomosc;
  private
  wcis: Boolean;
  sx,sy: Integer;
  dykty: TStringList;              // dykteryjki
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FGlowna: TFGlowna;
  //akmenusy: array[1..2] of array of TMenuItem;                    // wskaniki na komponenty menu
  deffol: String;
  listawyszu: array of String;

  aktust: TUsta;
  staust: TUsta;
  bezzap: Boolean = False;

  Parara: String;

  han: HWND;

  function Wizyte(q: TKarta): String;
  function FiltrujNazwe(s: String): String;
  function DStrNaString(t: String): String;
  function NazwaNaKompa(s: String): String;
  procedure WczytajUsta;
  procedure ZapiszUsta;
  procedure SortujTablKart(var Tabl: Tutu; Sposob: TSposobSort; Odwrotnie: Boolean);
  function RowneRekordy(a,b: TKarta): Boolean;
  function WersjaNormalnie: String;
  function DataNaDStr: String;
  function IleSklep: Byte;


implementation

uses Unit3, UBaza, Unit4, Unit5, Unit10;

{$R *.DFM}

procedure WczytajUsta;
var
f: file;
g: TUsta;
ui,s_wer: array[1..4] of Char;
begin
SetCurrentDir(deffol);
g:=Domyslne;
if FileExists('ustawienia') then begin
   AssignFile(f,'ustawienia');
   Reset(f,1);
   BlockRead(f,ui,SizeOf(ui));
   if ui=CUstaID then begin
      BlockRead(f,s_wer,SizeOf(s_wer));
      BlockRead(f,g,SizeOf(g));
      end;
   CloseFile(f);
   end;

//if (g.UstaID<>CUstaId) or (StrToInt(g.Wersja)<2000) then g:=Domyslne;
aktust:=g;
staust:=g;
FGlowna.Left:=g.MaiPkt.X;
FGlowna.Top:=g.MaiPkt.Y;
FGlowna.PokazBaza.Down:=g.PodJest;
FGlowna.PokazLista.Down:=g.LisJest;
FGlowna.PokazKomba.Down:=g.KomJest;
end;

procedure ZapiszUsta;
var
f: file;
begin
aktust.PodJest:=FBaza.Visible;
aktust.PodRozw:=rozw;
aktust.PodSkala:=FBaza.skala;
aktust.PodPkt.X:=FBaza.Left;
aktust.PodPkt.Y:=FBaza.Top;
aktust.LisJest:=FLista.Visible;
aktust.LisPkt.X:=FLista.Left;
aktust.LisPkt.Y:=FLista.Top;
aktust.MaiPkt.X:=FGlowna.Left;
aktust.MaiPkt.Y:=FGlowna.Top;
aktust.KomJest:=FKombo.Visible;
aktust.KomPkt.X:=FKombo.Left;
aktust.KomPkt.Y:=FKombo.Top;
SetCurrentDir(deffol);
AssignFile(f,'ustawienia');
Rewrite(f,1);
      BlockWrite(f,CUstaID,SizeOf(CUstaID));
      BlockWrite(f,wer,SizeOf(wer));
      BlockWrite(f,aktust,SizeOf(aktust));
CloseFile(f);
end;

procedure TFGlowna.ProcWiadomo(var msg: TMessage);
var
s,t: String;
f: TextFile;
begin
SetCurrentDir(deffol);
if not FileExists('temp.tmp') then exit;
AssignFile(f,'temp.tmp');
Reset(f);
ReadLn(f,s);
CloseFile(f);
DeleteFile('temp.tmp');
if not FileExists(s) then exit;

t:=AnsiLowerCase(ExtractFileExt(s));
if t='.pls' then with FLista do begin
   WczytajRdz(s);
   aktust.LisJest:=True;
   FGlowna.PokazLista.Down:=True;
   FLista.Show;
   end;
if t='.mwdeck' then with FKombo do begin
   WczytajRdz(s);
   aktust.KomJest:=True;
   FGlowna.PokazKomba.Down:=True;
   FKombo.Show;
   end;
end;

procedure TFGlowna.FormCreate(Sender: TObject);
var
f: TextFile;
const
Polski = 1045;
begin
deffol:=ExtractFileDir(Application.ExeName);
SetCurrentDir(deffol);

Parara:=ParamStr(1);
if Copy(Parara,1,1)='"' then begin
   Delete(Parara,1,1);
   Parara:=Copy(Parara,1,Pos('"',Parara)-1);
   end;

han:=0;
han:=FindWindow('TFGlowna',PAnsiChar('PieterCennik '+WersjaNormalnie));

if han<>0 then begin
   if Parara<>'' then begin
      AssignFile(f,'temp.tmp');
      Rewrite(f);
      WriteLn(f,Parara);
      CloseFile(f);
      PostMessage(han,wiadomosc,0,0);
      end;
   FGlowna.OnDestroy:=nil;
   exit;
   end;

wcis:=False;
if GetUserDefaultLCID<>Polski then MessageDlg('Current Windows Locale differs from standard Polish locale settings.'#13#10#13#10+
   'It may result in abnormal application behaviour.',mtWarning,[mbOK],0);
AddFontResource('MMedieval.ttf');
AddFontResource('MSymbols.ttf');
AddFontResource('MPlantin.ttf');
WczytajUsta;
Caption:='PieterCennik '+WersjaNormalnie;
WczytajCenniki;
StworzKomponenty;
WczytajDykte;
Wypis.Odswiez;
DopasujWysokosc;
SprawdzButon;
end;

procedure TFGlowna.StworzKomponenty;
var
i: Byte;
begin
TC.Tabs.Clear;
TC.Tabs.Add('Wszystko');
TC.Tabs.Add('Ujcie tabelkowe');
if Length(sklepy)>0 then for i:=0 to High(sklepy) do TC.Tabs.Add(NazwaNaKompa(sklepy[i].Atry.NazwaSklepu));
end;

procedure TFGlowna.WczytajCenniki;
var
f: file of Byte;
h,a,j: Integer;
sr: TSearchRec;
w: Word;
ss: String[6];
label nieplik;
begin
SetCurrentDir(deffol);
h:=FindFirst('*.cen',faAnyFile,sr);
while h=0 do begin
      AssignFile(f,sr.Name);
      Reset(f);
      BlockRead(f,ss,SizeOf(ss));
      if ss<>CNazwaID then begin
         if MessageDlg(Format(msUsunCen,[sr.Name]),mtWarning,[mbOK,mbAbort],0)=mrOK then DeleteFile(sr.Name);
         goto nieplik;
         end;
      BlockRead(f,w,SizeOf(Word));
      a:=Length(sklepy);
      SetLength(sklepy,a+1);
      SetLength(sklepy[a].Karty,w);
      BlockRead(f,sklepy[a].Atry,SizeOf(TSklepAtry));
      j:=0;
      while not Eof(f) do begin
            if j>High(sklepy[a].Karty) then begin
               MessageDlg('Bd wewntrzny KardNamberBedliAnnounced',mtError,[mbOK],0);
               break;
               end;
            BlockRead(f,sklepy[a].Karty[j],SizeOf(TKarta));
            Inc(j);
            end;
      nieplik:
      CloseFile(f);
      h:=FindNext(sr);
      end;
FindClose(sr);
end;

procedure TFGlowna.SprawdzButon;
var
i: Integer;
b: Boolean;
begin
b:=False;
for i:=0 to High(sklepy) do b:=(b or (sklepy[i].Atry.Data<>''));
BSzukaj.Enabled:=b;
BWszystko.Enabled:=b;
end;

function FiltrujNazwe(s: String): String;
const
     rv: array[1..12] of String = ('by','the','of','and','or','to','from','a','an','with','for','o'#39);
var
i,u: Integer;
t: String;
du: Boolean;
nagl: String;
begin
while Pos('  ',s)>0 do Delete(s,Pos('  ',s),1);
s:=LowerCase(Trim(s));
Result:='';
if s='' then exit;
repeat
      u:=Pos(' ',s);
      if u=0 then u:=Length(s);
      if (Pos('-',s)>0) and (Pos('-',s)<u) then u:=Pos('-',s);
      if (Pos('.',s)>0) and (Pos('.',s)<u) then u:=Pos('.',s);
      t:=Copy(s,1,u);
      Delete(s,1,u);
      nagl:='';
      while Copy(t,1,1)='(' do begin
         Delete(t,1,1);
         nagl:=nagl+'(';
         end;
      du:=True;
      for i:=1 to Length(rv) do if (Trim(t)=rv[i]) or
        (
        (Copy(t,1,Length(t)-1)=rv[i]) and (Copy(t,Length(t),1)='-')
        )
      then du:=False;
      if du then t:=UpperCase(Copy(t,1,1))+Copy(t,2,Length(t));
      Result:=Result+nagl+t;
      until s='';
u:=Pos('/',Result);
if (u>0) and (Length(Result)>u) then Result[u+1]:=UpCase(Result[u+1]);
if Length(Result)>0 then Result[1]:=UpCase(Result[1]);
u:=Pos('En-',Result);
if u>0 then Result[u]:='e';
end;

function DStrNaString(t: String): String;
const
mies: array[1..12] of String = (
'stycznia','lutego','marca','kwietnia',
'maja','czerwca','lipca','sierpnia',
'wrzenia','padziernika','listopada','grudnia'
);
begin
Result:=Copy(t,9,2)+' '+mies[StrToInt(Copy(t,6,2))]+' '+Copy(t,1,4)+'r.';
end;

function NazwaNaKompa(s: String): String;
begin
if Pos('&',s)>0 then Insert('&',s,Pos('&',s));
Result:=s;
end;

procedure TFGlowna.BSzukajClick(Sender: TObject);
var
c: String;
i: Integer;
begin
c:=FiltrujNazwe(Nazwa.Text);
Nazwa.Text:=c;
staust:=aktust;
for i:=0 to IleSklep-1 do UniSzuk(c,i,oNormalnie);
KonczWyszu;
end;

function TFGlowna.UniSzuk(naz: String; ns: Byte; opc: TTypWyszu): Boolean;
var
a,i,j: Integer;
cen: String;
label nast;
begin
Result:=False;
SetLength(sklepy[ns].Pftm,0);
if sklepy[ns].Atry.Data='' then exit;
naz:=LowerCase(naz);
if opc<>oNormalnie then begin
   for i:=0 to High(sklepy[ns].Karty) do if (sklepy[ns].Karty[i].Ilosc<>0) or (not aktust.Opcje[2]) then begin
       if opc=oLista then begin
          a:=-1;
          cen:=LowerCase(sklepy[ns].Karty[i].Nazwa);
          for j:=0 to Length(listawyszu)-1 do if listawyszu[j]=cen then begin
              a:=j;
              break;
              end;
          if a<0 then goto nast;
          end;
       a:=Length(sklepy[ns].Pftm);
       SetLength(sklepy[ns].Pftm,a+1);
       sklepy[ns].Pftm[a]:=@sklepy[ns].Karty[i];
       nast:
       end;
   if (aktust.Sortowanie<>ssNazwa) or aktust.Malejaco then SortujTablKart(sklepy[ns].Pftm,aktust.Sortowanie,aktust.Malejaco);
   exit;
   end;
for i:=0 to High(sklepy[ns].Karty) do if (sklepy[ns].Karty[i].Ilosc<>0) or (not aktust.Opcje[2]) then if
    ((naz=LowerCase(sklepy[ns].Karty[i].Nazwa)) and aktust.Opcje[0])
    or
    ((Pos(naz,LowerCase(sklepy[ns].Karty[i].Nazwa))>0) and not aktust.Opcje[0])
then begin
    a:=Length(sklepy[ns].Pftm);
    SetLength(sklepy[ns].Pftm,a+1);
    sklepy[ns].Pftm[a]:=@sklepy[ns].Karty[i];
    end;
if (aktust.Sortowanie<>ssNazwa) or aktust.Malejaco then SortujTablKart(sklepy[ns].Pftm,aktust.Sortowanie,aktust.Malejaco);
end;

procedure TFGlowna.WczytajDykte;
var
st: TStringList;
c,s: String;
a: Integer;
begin
SetCurrentDir(deffol);
dykty:=TStringList.Create;
if not FileExists('dykta.ini') then exit;
st:=TStringList.Create;
st.LoadFromFile('dykta.ini');
c:=st.Text;
st.Free;
repeat
      a:=Pos('*',c);
      if a=0 then a:=Length(c)+1;
      s:=Copy(c,1,a-1);
      Delete(c,1,a);
      while s[Length(s)] in [#10,#13] do Delete(s,Length(s),1);
      dykty.Add(s);
      until c='';
end;

procedure TFGlowna.LosujDykte;
var
a: Integer;
begin
if staust.Opcje[4] then begin
   Randomize;
   a:=Random(dykty.Count);
   MDykta.Caption:=dykty[a];
   end else MDykta.Caption:='';
end;

procedure TFGlowna.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
sx:=x;
sy:=y;
wcis:=True;
end;

procedure TFGlowna.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
if not (wcis and aktust.Opcje[3]) then exit;
Left:=Left+(x-sx);
Top:=Top+(y-sy);  
end;

procedure TFGlowna.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
wcis:=False;
end;

procedure TFGlowna.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if not bezzap then ZapiszUsta;
end;

procedure TFGlowna.Ustawienia1Click(Sender: TObject);
var
i: Integer;
begin
for i:=0 to Length(aktust.Opcje)-1 do FUsta.Zaz.Checked[i]:=aktust.Opcje[i];
with FUsta do begin
     case aktust.Sortowanie of
          ssNazwa: Rb1_1.Checked:=True;
          ssEdycja: Rb1_2.Checked:=True;
          ssStan: Rb1_3.Checked:=True;
          ssCena: Rb1_4.Checked:=True;
          end;
     if aktust.Malejaco then Rb2_2.Checked:=True else Rb2_1.Checked:=True;
     ShowModal;
     end;
end;

procedure TFGlowna.PokazBazaClick(Sender: TObject);
begin
if Sender=PokazBaza then FBaza.Visible:=PokazBaza.Down;
if Sender=PokazLista then FLista.Visible:=PokazLista.Down;
if Sender=PokazKomba then FKombo.Visible:=PokazKomba.Down;
end;

procedure TFGlowna.BWszystkoClick(Sender: TObject);
var
i: Integer;
begin
staust:=aktust;
for i:=0 to IleSklep-1 do UniSzuk('',i,oWszystko);
KonczWyszu;
end;

procedure TFGlowna.KonczWyszu;
var
i,j,k,a: Integer;
s,t,st: String;
uwu,fu: Byte;
li,bi: TStringList;
begin
if TC.TabIndex=1 then begin
   li:=TStringList.Create;
   li.CaseSensitive:=False;
   bi:=TStringList.Create;
   for i:=0 to High(sklepy) do for j:=0 to High(sklepy[i].Pftm) do begin
       s:=Wizyte(sklepy[i].Pftm[j]^);
       a:=Pos('*',s);
       while a>0 do begin
             s[a]:='#';
             a:=Pos('*',s);
             end;
       s:=s+'*'+PrzedluzStan(sklepy[i].Pftm[j].Stan);
       t:=sklepy[i].Pftm[j].Komentarz;
       if t<>'' then s:=s+' ('+t+')';
       s:=s+'*'+IntToStr(i)+'*'+IntToStr(j);
       li.Add(s);
       end;
   li.Sort;
   SetLength(Wypis.Source,0);
   SetLength(Wypis.LeftFroms,2+Length(sklepy));
   Wypis.LeftFroms[0]:=0;
   for i:=0 to High(sklepy)+1 do Wypis.LeftFroms[i+1]:=45*i+205;
   a:=-1;
   SetLength(Wypis.Source,li.Count,2+Length(sklepy));
   st:='';
   for k:=0 to li.Count-1 do begin
         s:=li[k];
         s:=StringReplace(s,'*',#13#10,[rfReplaceAll]);
         bi.Text:=s;
         t:=bi[0];
         if (a<0) or (st<>t+bi[1]) then begin
            Inc(a);
            for j:=0 to High(sklepy)+2 do begin
                if Pos('foil',bi[1])>0 then Wypis.Source[a,j].BackColor:=clCream else Wypis.Source[a,j].BackColor:=clWhite;
                Wypis.Source[a,j].Contents:='';
                if (j=0) or (j=High(sklepy)+2) then Wypis.Source[a,j].Color:=clBlack else Wypis.Source[a,j].Color:=sklepy[j-1].Atry.Kolor;
                Wypis.Source[a,j].Ad:=nil;
                end;
            Wypis.Source[a,0].Contents:=t;
            Wypis.Source[a,High(Wypis.Source[a])].Contents:=bi[1];
            st:=t+bi[1];
            end;
         i:=StrToInt(bi[2]); j:=StrToInt(bi[3]);
         Wypis.Source[a,i+1].Contents:=FloatToStrF(sklepy[i].Pftm[j].Cena,ffFixed,7,2);
         Wypis.Source[a,i+1].Ad:=sklepy[i].Pftm[j];
         Wypis.Source[a,i+1].IDSklepu:=i;
         Wypis.Source[a,0].Ad:=sklepy[i].Pftm[j];
         end;
    SetLength(Wypis.Source,a+1,2+Length(sklepy));
    li.Free;
    bi.Free;
    Wypis.Width:=45*High(sklepy)+343;
end else begin
if TC.TabIndex=0 then begin
   a:=0;
   for i:=0 to IleSklep-1 do if Length(sklepy[i].Pftm)>0 then Inc(a,Length(sklepy[i].Pftm)+2);
   if a>0 then Dec(a);
   end else a:=Length(sklepy[TC.TabIndex-2].Pftm);
SetLength(Wypis.Source,a,4);
SetLength(Wypis.LeftFroms,4);
for i:=0 to High(Wypis.Source) do for j:=0 to 3 do begin
    Wypis.Source[i,j].Color:=clBlack;
    Wypis.Source[i,j].BackColor:=clWhite;
    Wypis.Source[i,j].Ad:=nil;
    Wypis.Source[i,j].IDSklepu:=0;
    end;
Wypis.LeftFroms[0]:=0;
Wypis.LeftFroms[1]:=25;
Wypis.LeftFroms[2]:=230;
Wypis.LeftFroms[3]:=275;
a:=0;
if staust.Opcje[1] then uwu:=2 else uwu:=1;

for i:=0 to IleSklep-1 do if Pasuje(i) and (Length(sklepy[i].Pftm)>0) then begin
    if TC.TabIndex=0 then begin
       if a>0 then begin
          Wypis.Source[a,0].Contents:='';
          Wypis.Source[a,1].Contents:='';
          Wypis.Source[a,2].Contents:='';
          Wypis.Source[a,3].Contents:='';
          Inc(a);
          end;
       Wypis.Source[a,0].Contents:='';
       Wypis.Source[a,1].Contents:='   '+sklepy[i].Atry.NazwaSklepu;
       Wypis.Source[a,1].Color:=MaxInt;
       Wypis.Source[a,2].Contents:='';
       Wypis.Source[a,3].Contents:='';
       Inc(a);
       end;
    for fu:=1 to uwu do
    for j:=0 to High(sklepy[i].Pftm) do if (uwu=1) or ((fu=1)=sklepy[i].Pftm[j].Foliowany) then begin
        Wypis.Source[a,0].Contents:=Format('%d ',[sklepy[i].Pftm[j].Ilosc]);
        Wypis.Source[a,0].Ad:=sklepy[i].Pftm[j];
        Wypis.Source[a,1].Contents:=Wizyte(sklepy[i].Pftm[j]^);
        Wypis.Source[a,2].Contents:=FloatToStrF(sklepy[i].Pftm[j].Cena,ffFixed,7,2);
        Wypis.Source[a,2].Ad:=sklepy[i].Pftm[j];
        Wypis.Source[a,2].Color:=sklepy[i].Atry.Kolor;
        Wypis.Source[a,2].IDSklepu:=i;
        s:=PrzedluzStan(sklepy[i].Pftm[j].Stan);
        if sklepy[i].Pftm[j].Komentarz<>'' then s:=s+' ('+sklepy[i].Pftm[j].Komentarz+')';
        Wypis.Source[a,3].Contents:=s;
        if sklepy[i].Pftm[j].Foliowany then for k:=0 to 3 do Wypis.Source[a,k].BackColor:=clCream;
        Inc(a);
        end;
    end;
    Wypis.Width:=368;
end;
TC.Width:=Wypis.Width+13;
ScrollBar1.Left:=Wypis.Width+8;
Width:=Wypis.Width+40;
Sumama;
Wypis.Odswiez;
Nazwa.SelectAll;
end;

procedure TFGlowna.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
if bezzap then exit;
if MessageDlg('Czy na pewno chcesz wyj?',mtConfirmation,[mbYes,mbNo],0)=mrYes then CanClose:=True else CanClose:=False;
end;

procedure SortujTablKart(var Tabl: Tutu; Sposob: TSposobSort; Odwrotnie: Boolean);
var
a,i,j: Integer;
li: TStringList;
tempTabl: Tutu;
ced: String;
begin
li:=TStringList.Create;
li.CaseSensitive:=False;
SetLength(tempTabl,Length(Tabl));
ced:='';
for i:=0 to Length(Tabl)-1 do begin
    case Sposob of
         ssNazwa: ced:=Tabl[i].Nazwa+' '+cEdycje(Tabl[i].Edycja,1);
         ssEdycja: ced:=cEdycje(Tabl[i].Edycja,1)+' '+Tabl[i].Nazwa;
         ssStan: ced:=PrzedluzStan(Tabl[i].Stan)+' '+Tabl[i].Komentarz+' '+Tabl[i].Nazwa;
         ssCena: begin
                 ced:=CurrToStrF(Tabl[i].Cena,ffFixed,2);
                 for j:=Length(ced) to 6 do ced:='0'+ced;
                 ced:=ced+' '+Tabl[i].Nazwa+' '+cEdycje(Tabl[i].Edycja,1);
                 end;
         end;
    li.Add(ced+'**'+IntToStr(i));
    tempTabl[i]:=Tabl[i];
    end;
li.Sort;
for i:=0 to li.Count-1 do begin
    ced:=li[i];
    Delete(ced,1,Pos('**',ced)+1);
    if Odwrotnie then a:=li.Count-1-i else a:=i;
    Tabl[a]:=tempTabl[StrToInt(ced)];
    end;
li.Free;
end;

procedure TFGlowna.FormDestroy(Sender: TObject);
begin
dykty.Free;
SetCurrentDir(deffol);
RemoveFontResource('MMedieval.ttf');
RemoveFontResource('MSymbols.ttf');
RemoveFontResource('MPlantin.ttf');
end;

function RowneRekordy(a,b: TKarta): Boolean;
begin
Result:=True;
Result:=Result and (a.Nazwa=b.Nazwa);
Result:=Result and (a.Edycja=b.Edycja);
Result:=Result and (a.Komentarz=b.Komentarz);
Result:=Result and (a.Stan=b.Stan);
Result:=Result and (a.Foliowany=b.Foliowany);
end;

function WersjaNormalnie: String;
begin
Result:=wer;
if beta<>'' then Result:=Result+' '+beta;
end;

procedure TFGlowna.Oautorze1Click(Sender: TObject);
begin
FInfo:=TFInfo.Create(nil);
FInfo.ShowModal;
FInfo.Free;
end;

procedure TFGlowna.Pomoc1Click(Sender: TObject);
begin
SetCurrentDir(deffol);
WinHelp(FGlowna.Handle,'pomoc.hlp',HELP_CONTENTS,0);
end;

function DataNaDStr: String;
var
y,m,d: Word;
begin
DecodeDate(Date,y,m,d);
Result:=Format('%.4d-%.2d-%.2d',[y,m,d]);
end;

procedure TFGlowna.StatusTimerTimer(Sender: TObject);
begin
StatusBar1.Panels[1].Text:='';
StatusTimer.Enabled:=False;
end;

function IleSklep: Byte;
begin
Result:=Length(sklepy);
end;

procedure TFGlowna.ScrollBar1Change(Sender: TObject);
begin
Wypis.Offset:=ScrollBar1.Position;
end;

procedure TFGlowna.WypisNotify(Sender: TObject);
var
a: Integer;
begin
ScrollBar1.Height:=Wypis.Height;
ScrollBar1.Position:=0;
a:=Max(0,High(Wypis.Source)-Wypis.VisibleItems+1);
ScrollBar1.Max:=a;
ScrollBar1.Enabled:=(a>0);
LosujDykte;
DopasujWysokosc;
end;

procedure TFGlowna.DopasujWysokosc;
begin
MDykta.Top:=Wypis.Top+Wypis.Height+4;
FGlowna.Height:=MDykta.Top+MDykta.Height+70;
end;

procedure TFGlowna.WypisSelectItem(Index: Cardinal);
var
p: Pointer;
s: String;
a: Integer;
begin
p:=Wypis.Source[Index,0].Ad;
if not Assigned(p) then exit;
s:=TKarta(p^).Nazwa;
a:=FBaza.IDKarty(s);
//FBaza.InfoOKarcie(a);
FBaza.CalaZwykla(a);
end;

procedure TFGlowna.TCChange(Sender: TObject);
begin
if BSzukaj.Enabled then KonczWyszu;
end;

function TFGlowna.Pasuje(e: Byte): Boolean;
begin
Result:=((TC.TabIndex<2) or (TC.TabIndex=e+2));
end;

procedure TFGlowna.WypisDoubleClick(Karta: Pointer; Sklep: Byte);
begin
DodajDoListy(TKarta(Karta^),Sklep);
end;

procedure TFGlowna.Sumama;
var
a,i,j: Integer;
u: Single;
s: String;
begin
a:=0; u:=0;
for i:=0 to High(sklepy) do if Pasuje(i) then for j:=0 to High(sklepy[i].Pftm) do begin
    a:=a+sklepy[i].Pftm[j].Ilosc;
    u:=u+(sklepy[i].Pftm[j].Cena*sklepy[i].Pftm[j].Ilosc);
    end;
s:=FloatToStrF(u,ffNumber,18,2);
StatusBar1.SimpleText:=Format('Znaleziono %s o cznej wartoci %s PLN',[OdmienKarte(a),s]);
end;

function Wizyte(q: TKarta): String;
begin
Result:=Format('%s  %s',[q.Nazwa,cEdycje(q.Edycja,1)]);
end;

procedure TFGlowna.WypisMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
ScrollBar1.Position:=ScrollBar1.Position-(WheelDelta div 20);
Handled:=True;
end;

end.
