unit Unit10;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, CennikListView, StdCtrls, Math, Typy, Buttons, ToolWin, ComCtrls;

type
  TFKombo = class(TForm)
    Lypis: TCennikListView;
    ScrollBar1: TScrollBar;
    SbPlus: TSpeedButton;
    SbMinus: TSpeedButton;
    SbReset: TSpeedButton;
    SbTS: TSpeedButton;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    mInfo: TMemo;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    procedure LypisDragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure LypisNotify(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure LypisDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ScrollBar1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure LypisSelectItem(Index: Cardinal);
    procedure SbPlusClick(Sender: TObject);
    procedure LypisDoubleClick(Karta: Pointer; Sklep: Byte);
    procedure SbResetClick(Sender: TObject);
    procedure SbTSClick(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure LypisMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
  private
  _PlikKomba: String;
    { Private declarations }
  public
  procedure SetPlikKomba(n: String);
  property PlikKomba: String read _PlikKomba write SetPlikKomba;
  procedure WyczyscKombo;
  procedure Podsumuj;
  procedure DodajDoKomba(ptr: pTRek; sb: Boolean; ile: Word; defT: Byte = 0; defNazwa: String = '');
  procedure Usun(a: SmallInt);
  procedure DodajSobie(bazaindex: Integer; sb: Boolean);
  procedure WczytajRdz(NaPliku: String);
    { Public declarations }
  end;

var
  FKombo: TFKombo;
  Nagl: array[0..3] of Word;
  Suma: array[0..3] of Word;

implementation

uses Unit1,UBaza, Unit11;

{$R *.dfm}

procedure TFKombo.LypisDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
Accept:=(Source.ClassName='TListBox');
end;

procedure TFKombo.LypisNotify(Sender: TObject);
var
a: Integer;
begin
ScrollBar1.Height:=Lypis.Height;
FKombo.ClientHeight:=Lypis.Height+Lypis.Top;
a:=Max(0,High(Lypis.Source)-Lypis.VisibleItems+1);
ScrollBar1.Max:=a;
ScrollBar1.Enabled:=(a>0);
end;

procedure TFKombo.FormCreate(Sender: TObject);
begin
FKombo.Left:=aktust.KomPkt.X;
FKombo.Top:=aktust.KomPkt.Y;
FKombo.Visible:=aktust.KomJest;
SetLength(Lypis.LeftFroms,2);
Lypis.LeftFroms[0]:=0;
Lypis.LeftFroms[1]:=20;
if SameText(Copy(Parara,Length(Parara)-6,7),'.mwDeck') then begin
   WczytajRdz(Parara);
   aktust.KomJest:=True;
   FGlowna.PokazKomba.Down:=True;
   FKombo.Show;
   end else begin
   WyczyscKombo;
   mInfo.Lines.Add('Plik utworzony za pomoc programu PieterCennik');
   mInfo.Lines.Add('');
   mInfo.Lines.Add('Nazwa: ');
   mInfo.Lines.Add('Autor: ');
   Podsumuj;
   Lypis.Odswiez;
   end;
end;

procedure TFKombo.WyczyscKombo;
var
i,j: Byte;
begin
mInfo.Clear;

SetLength(Lypis.Source,8,2);
for i:=0 to 7 do for j:=0 to 1 do with Lypis.Source[i,j] do begin
    Contents:='';
    if (i and 1)=1 then Color:=clBlack else Color:=MaxInt;
    BackColor:=clWhite;
    Ad:=nil;
    IDSklepu:=0;
    end;
Nagl[0]:=0;
Nagl[1]:=2;
Nagl[2]:=4;
Nagl[3]:=6;
PlikKomba:='';
end;

procedure TFKombo.DodajDoKomba(ptr: pTRek; sb: Boolean; ile: Word; defT: Byte = 0; defNazwa: String = '');
var
a,l,v: SmallInt;
s: String;
t: Byte;
begin
if Assigned(ptr) then begin
   s:=ptr.Typ;
   if sb then t:=3 else begin
      if (Copy(s,1,8)='Creature') or (Copy(s,1,17)='Artifact Creature') then t:=1 else t:=2;
      if ptr.Kolor=6 then t:=0;
      end;
   s:=ptr.Nazwa;
   end else begin
   t:=defT;
   s:=defNazwa;
   end;

   if t=3 then l:=High(Lypis.Source)-1 else l:=Nagl[t+1]-2;
   a:=Nagl[t]+1;
   while a<=l do begin
       if Lypis.Source[a,1].Contents>s then break;
       Inc(a);
       end;
   v:=Length(Lypis.Source);
   SetLength(Lypis.Source,v+1,2);
   for l:=v-1 downto a do begin
       Lypis.Source[l+1,0]:=Lypis.Source[l,0];
       Lypis.Source[l+1,1]:=Lypis.Source[l,1];
       end;
   for l:=t+1 to 3 do Nagl[l]:=Nagl[l]+1;
   Lypis.Source[a,0].Contents:=IntToStr(ile);
   Lypis.Source[a,1].Contents:=s;
   Lypis.Source[a,1].Ad:=ptr;
   for l:=0 to 1 do if Assigned(ptr) then Lypis.Source[a,l].Color:=clBlack else Lypis.Source[a,l].Color:=clNavy;
end;

procedure TFKombo.LypisDragDrop(Sender, Source: TObject; X, Y: Integer);
var
a: SmallInt;
begin
if Source.ClassName='TListBox' then begin
   a:=TListBox(Source).ItemIndex;
   if a<0 then exit;
   DodajDoKomba(@baza[itemsy[a+1]],False,1);
   Podsumuj;
   Lypis.Odswiez;
   end;
end;

procedure TFKombo.ScrollBar1Change(Sender: TObject);
begin
Lypis.Offset:=ScrollBar1.Position;
end;

procedure TFKombo.Podsumuj;
const
arr: array[0..3] of String = (
'Ldy',
'Stwory',
'Inne czary',
'Sideboard'
);
var
a,b,l: SmallInt;
c,cc: Cardinal;
s: String;
begin
cc:=0;
for a:=0 to 3 do begin
    c:=0;
    if a=3 then l:=High(Lypis.Source)-1 else l:=Nagl[a+1]-2;
    for b:=Nagl[a]+1 to l do Inc(c,StrToInt(Lypis.Source[b,0].Contents));
    Suma[a]:=c;
    if a<3 then Inc(cc,c);
    end;
for a:=0 to 3 do begin
    if a=3 then s:='%s (%d):' else s:='%s (%d/%d):';
    Lypis.Source[Nagl[a],1].Contents:=Format(s,[arr[a],Suma[a],cc]);
    end;
end;

procedure TFKombo.FormClose(Sender: TObject; var Action: TCloseAction);
begin
FGlowna.PokazKomba.Down:=False;
end;

procedure TFKombo.LypisSelectItem(Index: Cardinal);
var
a: SmallInt;
var
s: String;
begin
s:=Lypis.Source[Index,1].Contents;
if Lypis.Source[Index,1].PartHide then Lypis.Hint:=s else Lypis.Hint:='';

if Lypis.Source[Index,0].Contents='' then exit;
a:=FBaza.IDKarty(s);
if a>0 then begin
   FBaza.CalaZwykla(a);
   //FBaza.InfoOKarcie(a);
   end;
end;

procedure TFKombo.SbPlusClick(Sender: TObject);
var
a: Integer;
c: Word;
d: ShortInt;
begin
a:=Lypis.Selected;
d:=0;
if Sender=SbPlus then d:=1;
if Sender=SbMinus then d:=-1;
if (a>=0) and (Lypis.Source[a,0].Contents<>'') then begin
   c:=StrToInt(Lypis.Source[a,0].Contents);
   if (c+d<30000) and (c+d>0) then Inc(c,d);
   Lypis.Source[a,0].Contents:=IntToStr(c);
   Podsumuj;
   Lypis.Repaint;
   end;
end;

procedure TFKombo.LypisDoubleClick(Karta: Pointer; Sklep: Byte);
var
g: Boolean;
a: Integer;
s: String;
begin
a:=Lypis.Selected;
if (a<0) or not FGlowna.BSzukaj.Enabled then exit;
g:=aktust.Opcje[0];
aktust.Opcje[0]:=True;
s:=Lypis.Source[a,1].Contents;
with FGlowna do begin
     Nazwa.Text:=s;
     BSzukaj.Click;
     end;
aktust.Opcje[0]:=g;
end;

procedure TFKombo.SbResetClick(Sender: TObject);
var
a: SmallInt;
begin
a:=Lypis.Selected;
if (a>=0) and (Lypis.Source[a,0].Contents<>'') then begin
   Usun(a);
   Podsumuj;
   Lypis.Odswiez;
   end;
end;

procedure TFKombo.Usun(a: SmallInt);
var
i: SmallInt;
begin
for i:=a to High(Lypis.Source)-1 do begin
    Lypis.Source[i,0]:=Lypis.Source[i+1,0];
    Lypis.Source[i,1]:=Lypis.Source[i+1,1];
    end;
SetLength(Lypis.Source,Length(Lypis.Source)-1,2);
for i:=0 to 3 do if Nagl[i]>a then Dec(Nagl[i]);
end;

procedure TFKombo.SbTSClick(Sender: TObject);
var
a: SmallInt;
ff: pTRek;
bbc: Boolean;
c: Word;
t: Byte;
s: String;
begin
a:=Lypis.Selected;
if (a>=0) and (Lypis.Source[a,0].Contents<>'') then begin
   ff:=Lypis.Source[a,1].Ad;
   s:=Lypis.Source[a,1].Contents;
   c:=StrToInt(Lypis.Source[a,0].Contents);
   bbc:=(a>Nagl[3]);
   if not Assigned(ff) and bbc then begin
      t:=FKtoraGrupa.ShowModal;
      if t<$10 then exit else Dec(t,$10);
      end else t:=3;
   Usun(a);
   DodajDoKomba(ff,not bbc,c,t,s);
   Podsumuj;
   Lypis.Odswiez;
   end;
end;

procedure TFKombo.DodajSobie(bazaindex: Integer; sb: Boolean);
begin
DodajDoKomba(@baza[itemsy[bazaindex+1]],sb,1);
Podsumuj;
Lypis.Odswiez;
end;

procedure TFKombo.ToolButton1Click(Sender: TObject);
begin
WyczyscKombo;
mInfo.Lines.Add('Plik utworzony za pomoc programu PieterCennik');
mInfo.Lines.Add('');
mInfo.Lines.Add('Nazwa: ');
mInfo.Lines.Add('Autor: ');
Podsumuj;
Lypis.Odswiez;
end;

procedure TFKombo.LypisMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
ScrollBar1.Position:=ScrollBar1.Position-Sign(WheelDelta);
Handled:=True;
end;

procedure TFKombo.ToolButton2Click(Sender: TObject);
var
dial: TOpenDialog;
begin
SetCurrentDir(deffol);
dial:=TOpenDialog.Create(FKombo);
dial.Filter:='Talie i komba|*.mwDeck';
dial.Title:='Otwrz plik talii Magic Workstation...';
dial.Options:=[ofFileMustExist,ofHideReadOnly];
if (aktust.DialFol<>'') then if DirectoryExists(aktust.DialFol) then dial.InitialDir:=aktust.DialFol;
if dial.Execute and (FileExists(dial.FileName)) then WczytajRdz(dial.Filename);
SetCurrentDir(deffol);
dial.Free;
end;

procedure TFKombo.WczytajRdz(NaPliku: String);
const nienie: array[0..8] of String = (
'lands',
'creatures',
'other spells',
'sideboard',
'lady',
'stwory',
'inne czary',
'sideboard',
'ldy'
);
var
plik: TextFile;
a: SmallInt;
c: SmallInt;
s: String;
b: Boolean;
ptr: pTRek;
defetyzm: Byte;
lii: TStringList;
begin
lii:=TStringList.Create;
   defetyzm:=0;
   WyczyscKombo;
   AssignFile(plik,NaPliku);
   Reset(plik);
   while not Eof(plik) do begin
         ReadLn(plik,s);
         s:=Trim(s);
         if (s='') or (Copy(s,1,2)='//') then begin
            if s<>'' then begin
               Delete(s,1,2);
               s:=TrimLeft(s);
               end;
            b:=True;
            for a:=0 to High(nienie) do if SameText(s,nienie[a]) then begin
                b:=False;
                defetyzm:=a mod 4;
                break;
                end;
            if lii.Count>0 then if lii[lii.Count-1]=s then b:=False;
            if b then lii.Add(s);
            end else begin
            b:=False;
            if Copy(s,1,2)='SB' then begin
               b:=True;
               Delete(s,1,2);
               while (Copy(s,1,1)=':') or (Copy(s,1,1)=' ') do Delete(s,1,1);
               end;
            c:=StrToIntDef(Copy(s,1,Pos(' ',s)-1),-1);
            if c>0 then begin
               Delete(s,1,Pos(' ',s));
               s:=TrimLeft(s);
               if Copy(s,1,1)='[' then begin
                  if Pos(']',s)>0 then Delete(s,1,Pos(']',s)) else Delete(s,1,Pos(' ',s));
                  end;
               s:=TrimLeft(s);
               ptr:=nil;
               for a:=1 to FBaza.il do if SameText(s,Baza[a].Nazwa) then begin
                   ptr:=@Baza[a];
                   break;
                   end;
               DodajDoKomba(ptr,b,c,defetyzm,s);
               end else if c<0 then MessageDlg('Napotkano bd w poniszej linii pliku talii:'#13#10+s+#13#10#13#10'Linia zostanie pominita przy wczytywaniu.',mtWarning,[mbOK],0);
            end;
         end;
   while (lii.Count>0) and (lii[lii.Count-1]='') do lii.Delete(lii.Count-1);
   CloseFile(plik);
   PlikKomba:=NaPliku;
   aktust.DialFol:=ExtractFileDir(NaPliku);
   Podsumuj;
   Lypis.Odswiez;
   mInfo.Text:=lii.Text;
lii.Free;
end;

procedure TFKombo.ToolButton3Click(Sender: TObject);
const
nagla: array[0..3] of String = (
'Lady',
'Stwory',
'Inne czary',
'Sideboard'
);
var
dial: TSaveDialog;
plik: TextFile;
i: Integer;
s: String;
a: ShortInt;
begin
SetCurrentDir(deffol);
dial:=TSaveDialog.Create(FKombo);
dial.Filter:='Talie i komba|*.mwDeck';
dial.Title:='Zapisz plik talii Magic Workstation...';
dial.FileName:='Talia '+DataNaDStr+'.mwDeck';
dial.Options:=[ofOverwritePrompt];
if (aktust.DialFol<>'') then if DirectoryExists(aktust.DialFol) then dial.InitialDir:=aktust.DialFol;
if PlikKomba<>'' then begin
   dial.InitialDir:=ExtractFileDir(PlikKomba);
   dial.FileName:=ExtractFileName(PlikKomba);
   end else begin
   for i:=0 to mInfo.Lines.Count-1 do if Copy(mInfo.Lines[i],1,6)='Nazwa:' then begin
       s:=Trim(Copy(mInfo.Lines[i],7,Length(mInfo.Lines[i])));
       if s<>'' then dial.FileName:=s+'.mwDeck';
       break;
       end;
   end;
if dial.Execute then begin
   s:=dial.FileName;
   if not SameText(Copy(s,Length(s)-6,7),'.mwDeck') then s:=s+'.mwDeck';
   AssignFile(plik,s);
   Rewrite(plik);
   PlikKomba:=s;
   for i:=0 to mInfo.Lines.Count-1 do begin
       s:=mInfo.Lines[i];
       if s<>'' then s:='// '+s;
       WriteLn(plik,s);
       end;
   a:=-1;
   for i:=0 to High(Lypis.Source) do begin
       if (a<3) and (i=nagl[a+1]) then begin
          Inc(a);
          if suma[a]>0 then begin
             WriteLn(plik,'');
             WriteLn(plik,'// '+nagla[a]);
             end;
          end else if Lypis.Source[i,0].Contents<>'' then begin
          if a=3 then s:='SB: ' else s:='';
          s:=s+Lypis.Source[i,0].Contents+' [] '+Lypis.Source[i,1].Contents;
          WriteLn(plik,s);
          end;
       end;
   CloseFile(plik);
   aktust.DialFol:=ExtractFileDir(dial.FileName);
   end;
SetCurrentDir(deffol);
dial.Free;
end;

procedure TFKombo.SetPlikKomba(n: String);
var
s: String;
begin
s:='Edytor talii';
if n<>'' then s:=s+' - '+ExtractFileName(n);
Caption:=s;
_PlikKomba:=n;
end;

procedure TFKombo.ToolButton5Click(Sender: TObject);
var
s: String;
ptr: pTRek;
a: Word;
begin
s:=InputBox('Dodawanie karty','Wpisz nazw karty ktr chcesz doda:','');
if s<>'' then begin
   ptr:=nil;
   for a:=1 to FBaza.il do if SameText(s,Baza[a].Nazwa) then begin
       ptr:=@Baza[a];
       break;
       end;
   if Assigned(ptr) then a:=0 else begin
      a:=FKtoraGrupa.ShowModal;
      if a<$10 then exit else Dec(a,$10);
      end;
   DodajDoKomba(ptr,False,1,a,s);
   Podsumuj;
   Lypis.Odswiez;
   end;
end;

procedure TFKombo.ToolButton6Click(Sender: TObject);
var
g: Boolean;
a,b,i,wsie: Word;
j: Byte;
cena: Single;
minc,maxc: Double;
minw,maxw: Double;
s: String;
nieu: Word;
li: TStringList;
begin
if not FGlowna.BSzukaj.Enabled then begin
   MessageDlg('Aby mc wycenia talie, musisz zaktualizowa cennik przynajmniej jednego sklepu.',mtError,[mbOK],0);
   exit;
   end;
g:=aktust.Opcje[0];
aktust.Opcje[0]:=True;
minw:=0; maxw:=0; nieu:=0;
li:=TStringList.Create;
li.Sorted:=True;
wsie:=0;
for i:=0 to High(Lypis.Source) do if Lypis.Source[i,0].Contents<>'' then begin
    a:=StrToInt(Lypis.Source[i,0].Contents);
    Inc(wsie,a);
    s:=Lypis.Source[i,1].Contents;
    cena:=0; minc:=0; maxc:=0;
    if Assigned(Lypis.Source[i,1].Ad) then begin
       for j:=0 to IleSklep-1 do FGlowna.UniSzuk(s,j,oNormalnie);
       for j:=0 to IleSklep-1 do if Length(sklepy[j].Pftm)>0 then for b:=0 to High(sklepy[j].Pftm) do begin
           cena:=sklepy[j].Pftm[b].Cena;
           if cena>maxc then maxc:=cena;
           if (minc=0) or (cena<minc) then minc:=cena;
           end;
       minw:=minw+(a*minc);
       maxw:=maxw+(a*maxc);
       end;
    if cena=0 then begin
       li.Add(IntToStr(a)+'x '+s);
       Inc(nieu,a);
       end;
    end;
for j:=0 to IleSklep-1 do SetLength(sklepy[j].Pftm,0);
FGlowna.KonczWyszu;
aktust.Opcje[0]:=g;

s:='Prba wyceny talii zostaa zakoczona.'#13#10#13#10'Wartoci graniczne wycenionych kart zawieraj si pomidzy:'#13#10;
s:=s+'maksimum: '+FloatToStrF(maxw,ffFixed,7,2)+#13#10;
s:=s+'minimum: '+FloatToStrF(minw,ffFixed,7,2);
if li.Count>0 then begin
   s:=s+#13#10#13#10+Format('Nie udao si wyceni %d pozycji (%d kart):',[li.Count,nieu]);
   for i:=0 to li.Count-1 do s:=s+#13#10+li[i];
   end;
if wsie=0 then wsie:=1;
cena:=((maxw+minw)/2)*(1+(nieu/wsie));
s:=s+#13#10#13#10+'redni warto caej talii szacuje si na '+FloatToStrF(cena,ffFixed,7,2)+' PLN';

li.Free;
MessageDlg(s,mtInformation,[mbOK],0);
end;

end.
