unit Unit4;

interface

uses
  Windows, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Typy, Math, Buttons, ComCtrls, ToolWin,
  ImgList;

type
  TFLista = class(TForm)
    ListBox1: TListBox;
    ListBox2: TListBox;
    ListBox3: TListBox;
    ListBox4: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ScrollBar1: TScrollBar;
    GroupBox1: TGroupBox;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    GroupBox2: TGroupBox;
    SbPlus: TSpeedButton;
    SbMinus: TSpeedButton;
    SbReset: TSpeedButton;
    ERazem: TLabeledEdit;
    Red: TRichEdit;
    ToolBar1: TToolBar;
    TbNew: TToolButton;
    TbOpen: TToolButton;
    TbSave: TToolButton;
    ToolButton4: TToolButton;
    TbPrint: TToolButton;
    ImageList1: TImageList;
    TbTxt: TToolButton;
    ToolButton1: TToolButton;
    procedure ListBox1Data(Control: TWinControl; Index: Integer;
      var Data: String);
    procedure FormCreate(Sender: TObject);
    procedure UstawCounty;
    procedure ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListBox3DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure ScrollBar1Change(Sender: TObject);
    procedure SbPlusClick(Sender: TObject);
    procedure SbResetClick(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
    procedure Adsumus;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TbNewClick(Sender: TObject);
    procedure TbSaveClick(Sender: TObject);
    procedure TbOpenClick(Sender: TObject);
    procedure WczytajRdz(s: String);
    procedure LabeledEdit3Change(Sender: TObject);
    function NaTekst(RTF, Stopka: Boolean): Boolean;
    procedure TbPrintClick(Sender: TObject);
    procedure TbTxtClick(Sender: TObject);
    procedure Kapcie;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FLista: TFLista;
  Lista: array of TKartaLista;
  PlikListy: String;

function DodajDoListy(Karta: TKarta; NumerSklepu: Integer): Integer;
procedure UsunZListy(Index: Integer);
procedure WyczyscListe;
function PrzedluzStan(const ste: String): String;

implementation

uses Unit1, UBaza;

{$R *.dfm}

function DodajDoListy(Karta: TKarta; NumerSklepu: Integer): Integer;
var
h: TKartaLista;
i,a,u: Integer;
begin
h.Nazwa:=Karta.Nazwa;
h.Edycja:=Karta.Edycja;
h.Cena:=Karta.Cena;
h.Ilosc:=1;
h.Sklep:=NumerSklepu;
h.Uwagi:='';
h.Komentarz:=Karta.Stan;
if Karta.Komentarz<>'' then h.Komentarz:=h.Komentarz+' '+Karta.Komentarz;
a:=Length(Lista);
SetLength(Lista,a+1);
u:=-1;
for i:=0 to a-1 do if Lista[i].Nazwa>Karta.Nazwa then begin
    u:=i;
    break;
    end;
if u>=0 then begin
   for i:=a-1 downto u do Lista[i+1]:=Lista[i];
   Lista[u]:=h;
   Result:=u;
end else begin
    Lista[a]:=h;
    Result:=a;
end;
FLista.UstawCounty;
end;

procedure UsunZListy(Index: Integer);
var
i: Integer;
begin
for i:=Index to Length(Lista)-2 do Lista[i]:=Lista[i+1];
SetLength(Lista,Max(0,Length(Lista)-1));
FLista.UstawCounty;
end;

procedure TFLista.ListBox1Data(Control: TWinControl; Index: Integer;
  var Data: String);
var
a: Integer;
begin
a:=Index+ScrollBar1.Position;
case Control.Tag of
     1: Data:=IntToStr(Lista[a].Ilosc);
     2: Data:=Lista[a].Nazwa;
     3: Data:=CurrToStrF(Lista[a].Cena,ffFixed,2);
     4: Data:=CurrToStrF(Lista[a].Cena*Lista[a].Ilosc,ffFixed,2);
     end;
end;

procedure WyczyscListe;
begin
SetLength(Lista,0);
FLista.UstawCounty;
end;

procedure TFLista.FormCreate(Sender: TObject);
begin
WyczyscListe;
FLista.Left:=aktust.LisPkt.X;
FLista.Top:=aktust.LisPkt.Y;
FLista.Visible:=aktust.LisJest;
PlikListy:='';
if SameText(Copy(Parara,Length(Parara)-3,4),'.pcl') then begin
   WczytajRdz(Parara);
   aktust.LisJest:=True;
   FGlowna.PokazLista.Down:=True;
   FLista.Show;
   end;
end;

procedure TFLista.UstawCounty;
var
a: Integer;
begin
a:=Min(20,Length(Lista));
ListBox1.Count:=a;
ListBox2.Count:=a;
ListBox3.Count:=a;
ListBox4.Count:=a;
a:=Max(0,Length(Lista)-20);
ScrollBar1.Position:=0;
ScrollBar1.Max:=a;
ScrollBar1.Visible:=(a>0);
Adsumus;
end;

procedure TFLista.ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if Sender<>ListBox1 then ListBox1.ItemIndex:=-1;
if Sender<>ListBox2 then ListBox2.ItemIndex:=-1;
if Sender<>ListBox3 then ListBox3.ItemIndex:=-1;
if Sender<>ListBox4 then ListBox4.ItemIndex:=-1;
end;

procedure TFLista.ListBox3DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
s: String;
f,b,pp: TColor;
begin
s:=TListBox(Control).Items[Index];
with TListBox(Control) do begin
     if Control=ListBox3 then f:=sklepy[Lista[Index+ScrollBar1.Position].Sklep].Atry.Kolor else f:=clBlack;
     b:=clWhite;
     if odSelected in State then begin
        pp:=b;
        b:=f;
        f:=pp;
        if b=clBlack then b:=clDkGray;
        end;
     Canvas.Brush.Color:=b;
     Canvas.Font.Color:=f;
     Canvas.TextRect(Rect,1,Index*ItemHeight,s);
     end;
end;

procedure TFLista.ScrollBar1Change(Sender: TObject);
begin
ListBox1.Refresh;
ListBox2.Refresh;
ListBox3.Refresh;
ListBox4.Refresh;
end;

procedure TFLista.SbPlusClick(Sender: TObject);
var
a: Integer;
step: ShortInt;
begin
if Sender=SbPlus then step:=1 else step:=-1;
if ListBox1.ItemIndex>-1 then begin
   a:=ListBox1.ItemIndex+ScrollBar1.Position;
   if Lista[a].Ilosc+step<=0 then exit;
   if Lista[a].Ilosc+step>=High(ShortInt) then exit;
   Inc(Lista[a].Ilosc,step);
   ListBox1.Refresh;
   ListBox4.Refresh;
   Adsumus;
   end;
end;

procedure TFLista.SbResetClick(Sender: TObject);
var
a: Integer;
begin
if ListBox1.ItemIndex>-1 then begin
   a:=ListBox1.ItemIndex+ScrollBar1.Position;
   Lista[a].Ilosc:=1;
   ListBox1.Refresh;
   ListBox4.Refresh;
   Adsumus;
   end;
if ListBox2.ItemIndex>-1 then begin
   a:=ListBox2.ItemIndex+ScrollBar1.Position;
   UsunZListy(a);
   end;
end;

procedure TFLista.ListBox2Click(Sender: TObject);
var
a: Integer;
begin
a:=TListBox(Sender).ItemIndex;
if a<0 then exit;
if ScrollBar1.Visible then Inc(a,ScrollBar1.Position);
LabeledEdit1.Text:=cEdycje(Lista[a].Edycja,1);
LabeledEdit2.Text:=Lista[a].Komentarz;
LabeledEdit3.Text:=Lista[a].Uwagi;
FBaza.CalaZwykla(FBaza.IDKarty(Lista[a].Nazwa));
end;

procedure TFLista.Adsumus;
var
i: Integer;
a: Single;
begin
a:=0;
for i:=0 to Length(Lista)-1 do a:=a+(Lista[i].Ilosc*Lista[i].Cena);
ERazem.Text:=CurrToStrF(a,ffFixed,2);
end;

procedure TFLista.FormClose(Sender: TObject; var Action: TCloseAction);
begin
FGlowna.PokazLista.Down:=False;
end;

function PrzedluzStan(const ste: String): String;
var
t: String;
begin
t:=ste;
t:=StringReplace(t,'+',' +',[]);
t:=StringReplace(t,'-',' -',[]);
if Pos('NM',t)>0 then t:=StringReplace(t,'NM','Near Mint',[]) else begin
   t:=StringReplace(t,'F','Fine',[]);
   t:=StringReplace(t,'G','Good',[]);
   t:=StringReplace(t,'P','Poor',[]);
   t:=StringReplace(t,'EX','Excellent',[]);
   t:=StringReplace(t,'M','Mint',[]);
   end;
Result:=t;
end;

procedure TFLista.TbNewClick(Sender: TObject);
begin
WyczyscListe;
PlikListy:='';
Kapcie;
end;

procedure TFLista.TbOpenClick(Sender: TObject);
var
dial: TOpenDialog;
begin
SetCurrentDir(deffol);
dial:=TOpenDialog.Create(FLista);
dial.Filter:='Listy kart PieterCennika|*.pcl';
dial.Title:='Otwrz list kart PieterCennika...';
dial.Options:=[ofFileMustExist,ofHideReadOnly];
if (aktust.DialFol<>'') then if DirectoryExists(aktust.DialFol) then dial.InitialDir:=aktust.DialFol;
if dial.Execute and FileExists(dial.FileName) then WczytajRdz(dial.FileName);
SetCurrentDir(deffol);
dial.Free;
end;

procedure TFLista.WczytajRdz(s: String);
var
plik: file of TKartaLista;
kl: TKartaLista;
a: Integer;
begin
   AssignFile(plik,s);
   Reset(plik);
   Read(plik,kl);
   if kl.Komentarz<>CNazwaID then begin
      MessageDlg('Wybrany plik nie jest poprawnym plikiem listy kart PieterCennika',mtError,[mbOk],0);
      CloseFile(plik);
      exit;
      end;
   SetLength(Lista,0);
   while not Eof(plik) do begin
         Read(plik,kl);
         a:=Length(Lista);
         SetLength(Lista,a+1);
         Lista[a]:=kl;
         end;
   CloseFile(plik);
   UstawCounty;
   aktust.DialFol:=ExtractFileDir(s);
   PlikListy:=s;
   Kapcie;
end;

procedure TFLista.TbSaveClick(Sender: TObject);
var
dial: TSaveDialog;
plik: file of TKartaLista;
kl: TKartaLista;
i: Integer;
s: String;
begin
SetCurrentDir(deffol);
dial:=TSaveDialog.Create(FLista);
dial.Filter:='Listy kart PieterCennika (*.pcl)|*.pcl';
dial.Title:='Zapisz list kart PieterCennika...';
dial.FileName:='Lista '+DataNaDStr+'.pcl';
dial.Options:=[ofOverwritePrompt];
if (aktust.DialFol<>'') then if DirectoryExists(aktust.DialFol) then dial.InitialDir:=aktust.DialFol;
if PlikListy<>'' then begin
   dial.InitialDir:=ExtractFileDir(PlikListy);
   dial.FileName:=ExtractFileName(PlikListy);
   end;
if dial.Execute then begin
   s:=dial.FileName;
   if not SameText(Copy(s,Length(s)-3,4),'.pcl') then s:=s+'.pcl';
   AssignFile(plik,s);
   Rewrite(plik);
   kl.Komentarz:=CNazwaID;
   Write(plik,kl);
   for i:=0 to Length(Lista)-1 do Write(plik,Lista[i]);
   CloseFile(plik);
   aktust.DialFol:=ExtractFileDir(dial.FileName);
   PlikListy:=s;
   Kapcie;
   end;
SetCurrentDir(deffol);
dial.Free;
end;

procedure TFLista.LabeledEdit3Change(Sender: TObject);
begin
if ListBox2.ItemIndex>-1 then Lista[ListBox2.ItemIndex+ScrollBar1.Position].Uwagi:=LabeledEdit3.Text;
end;

function TFLista.NaTekst(RTF, Stopka: Boolean): Boolean;
var
s,t: String;
a,i,j: Integer;
begin
if Length(Lista)=0 then begin
   Result:=False;
   if MessageDlg('Lista jest pusta. Czy mimo tego chcesz kontynuowa?',mtConfirmation,[mbYes,mbNo],0)<>mrYes then exit;
   end;
Result:=True;
Red.Clear;
Red.PlainText:=not RTF;
if Stopka then begin
   s:='Lista kart z dnia '+DStrNaString(DataNaDStr)+':';
   Red.Lines.Add(s);
   for i:=1 to Length(s) do s[i]:='-';
   Red.Lines.Add(s);
   Red.Lines.Add('');
   end;
a:=0;
for i:=0 to High(Lista) do a:=Max(a,Length(Lista[i].Nazwa));
Inc(a,2);
for i:=0 to High(Lista) do begin
    t:=IntToStr(Lista[i].Ilosc)+' ';
    if Length(t)<3 then t:=t+'.';
    for j:=Length(t) to 3 do t:=t+' ';
    s:=Lista[i].Nazwa+' ';
    for j:=Length(s) to a do s:=s+'.';
    s:=t+s+' ';
    t:=CurrToStrF(Lista[i].Cena,ffFixed,2)+' ';
    for j:=Length(t) to 8 do t:=t+'.';
    s:=s+t+' ';
    t:=CurrToStrF(Lista[i].Cena*Lista[i].Ilosc,ffFixed,2)+' ';
    for j:=Length(t) to 8 do t:=t+'.';
    s:=s+t+' ';
    t:=cEdycje(Lista[i].Edycja,2);

    if Lista[i].Komentarz<>'' then t:=t+' '+Lista[i].Komentarz;
    s:=s+'('+t+')';
    if Lista[i].Uwagi<>'' then s:=s+' '+Lista[i].Uwagi;
    Red.Lines.Add(s);
    end;
s:='Razem ... '+ERazem.Text;
for i:=1 to a+6 do s:=' '+s;
Red.Lines.Add('');
Red.Lines.Add(s);
if Stopka then begin
   Red.Lines.Add('');
   Red.Lines.Add('Lista zostaa utworzona za pomoc programu PieterCennik '+WersjaNormalnie+'.');
   Red.Lines.Add('PieterSoft  2002-'+rok+' by PieterEr');
   end;
end;

procedure TFLista.TbPrintClick(Sender: TObject);
begin
if NaTekst(False,True) then Red.Print('Lista kart - PieterCennik');
end;

procedure TFLista.TbTxtClick(Sender: TObject);
var
dial: TSaveDialog;
s: String;
begin
if not NaTekst(False,True) then exit;
dial:=TSaveDialog.Create(FLista);
dial.Filter:='Pliki tekstowe (*.txt)|*.txt';
dial.Title:='Eksportuj list jako plik tekstowy...';
dial.FileName:='Lista.txt';
dial.Options:=[ofOverwritePrompt];
if (aktust.DialFol<>'') then if DirectoryExists(aktust.DialFol) then dial.InitialDir:=aktust.DialFol;
if dial.Execute then begin
   s:=dial.FileName;
   if Copy(s,Length(s)-3,4)<>'.txt' then s:=s+'.txt';
   Red.Lines.SaveToFile(s);
   aktust.DialFol:=dial.InitialDir;
   end;
SetCurrentDir(deffol);
dial.Free;
end;

procedure TFLista.Kapcie;
var
s: String;
begin
s:='Edytor listy kart';
if PlikListy<>'' then s:=s+' - '+ExtractFileName(PlikListy);
Caption:=s;
end;

end.
